# Name: ...
# CSE 190P
# Homework 2: DNA analysis

# This program reads DNA sequencer output and computes statistics, such as
# the GC content.  Run it from the command line like this:
#   python dna_analysis.py myfile.fastq


# Load a module that supports reading files, command-line arguments, etc.
import sys


##
## This section of the program reads the nucleotides into a variable named seq.
##

# The file name specified on the command line, as a string.
filename = sys.argv[1]
# A file object from which data can be read.
inputfile = open(filename)

# All the nucleotides in the input file that have been read so far.
seq = ""
# The current line number (= the number of lines read so far).
linenum = 0


for line in inputfile:
  linenum = linenum + 1
  # if we are on the 2nd, 6th, 10th line...
  if linenum % 4 == 2:
    # Remove the newline characters from the end of the line
    line = line.rstrip()
    seq = seq + line


##
## This section of the program computes statistics.
## 

# Total nucleotides seen so far.
total_count = 0
# Number of G and C nucleotides seen so far.
gc_count = 0


# for each base pair in the string,
for bp in seq:
  # increment the total number of bps we've seen
  total_count = total_count + 1

  # next, if the bp is a G or a C,
  if bp == 'C' or bp == 'G':
    # increment the count of gc
    gc_count = gc_count + 1


# divide the gc_count by the total_count
gc_content = float(gc_count) / total_count

# Print the answer
print 'GC-content of', filename, "is", gc_content
